import 'package:dart_blocks/dart_blocks/components/text_field_decoration.dart';
import 'package:dart_blocks/dart_blocks/nuntio_client.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:modal_bottom_sheet/modal_bottom_sheet.dart';
import 'package:nuntio_blocks/block_user.pb.dart';
import 'package:pin_code_fields/pin_code_fields.dart';

class VerifyCodeSheet extends StatefulWidget {
  VerifyCodeSheet({
    Key? key,
    required this.verifyCodeTitle,
    required this.buttonHeight,
    required this.buttonWidth,
  }) : super(key: key);

  final Widget verifyCodeTitle;
  final double buttonWidth;
  final double buttonHeight;

  @override
  State<VerifyCodeSheet> createState() => _VerifyCodeSheetState();
}

class _VerifyCodeSheetState extends State<VerifyCodeSheet> {
  final emailController = TextEditingController();
  final passwordController = TextEditingController();
  final verifyCodeController = TextEditingController();
  bool isLoading = false;
  bool hasError = false;

  @override
  Widget build(BuildContext context) {
    return Container(
      height: 500,
      margin: EdgeInsets.all(20),
      child: Scaffold(
        body: Column(
          children: [
            widget.verifyCodeTitle,
            SizedBox(
              height: 50,
            ),
            PinCodeTextField(
              length: 6,
              obscureText: false,
              animationType: AnimationType.fade,
              cursorColor: CupertinoColors.white,
              enablePinAutofill: true,
              pinTheme: PinTheme(
                activeColor: Colors.grey[300],
                shape: PinCodeFieldShape.box,
                borderRadius: BorderRadius.circular(5),
                fieldHeight: 50,
                fieldWidth: 40,
                activeFillColor: CupertinoColors.white,
                selectedFillColor: CupertinoColors.white,
                errorBorderColor: CupertinoColors.systemRed,
                inactiveColor: CupertinoColors.lightBackgroundGray,
                inactiveFillColor: CupertinoColors.lightBackgroundGray,
                selectedColor: hasError
                    ? CupertinoColors.systemRed
                    : CupertinoColors.activeBlue,
              ),
              animationDuration: Duration(milliseconds: 300),
              enableActiveFill: true,
              controller: verifyCodeController,
              beforeTextPaste: (text) {
                print("Allowing to paste $text");
                //if you return true then it will show the paste confirmation dialog. Otherwise if false, then nothing will happen.
                //but you can show anything you want here, like your pop up saying wrong paste format or etc
                return true;
              },
              appContext: context,
              onChanged: (String value) {
                print(value);
              },
            ),
            SizedBox(
              height: 50,
            ),
            SizedBox(
              width: widget.buttonWidth,
              height: widget.buttonHeight,
              child: CupertinoButton(
                child: Text(
                  "Verify email",
                  style: TextStyle(color: Colors.white),
                ),
                color: CupertinoColors.black,
                onPressed: () {
                  if (isLoading) {
                    return;
                  }
                },
              ),
            ),
          ],
        ),
      ),
    );
  }
}
